;   le batch pour batir une librairie
;batch,sources et .inc (contenant les proto)

; #########################################################################

	.386                      ; force 32 bit code
	.model flat, stdcall      ; memory model & calling convention
	option casemap :none      ; case sensitive
	; --------------------------------
	; Les fichiers inclus ii
	; --------------------------------
	include \masm32\include\windows.inc
	include \masm32\include\kernel32.inc
	include \masm32\include\user32.inc
	include \masm32\include\masm32.inc
	include local_macros.txt

	; ---------------------------------------------------------
	; Les PROTO sont tous regroups dans un fichier .inc du mme
	; nom que la librairie .lib
	; ---------------------------------------------------------

.data
	ercharge db "Taille ",0
	texthou db " Handle fichier ",0
	textHmem db "Handle memoire ",0
	textPm db "Pointeur memoire ",0
	textlu db " Nb octets en lecture ",0
	InfosFiles WIN32_FIND_DATA <>

	.code
;################################################################
;----------- pushad popad -----------------
LoadFile proc uses ebx NomAediter:DWORD,PileMem:DWORD
		LOCAL retour:DWORD
		LOCAL fichier:DWORD
		local hMemory:DWORD
		local pMemory:DWORD
		local hFile:DWORD
		local NbOctetsaLire:DWORD
		local NbOctetsLus:DWORD

	;pilemem adresse d'une structure FichMem
	;rajoute un zero en fin de fichier
	;ncessaire dans les copies avec clipboard par exemple
	;utilise  WIN32_FIND_DATA et NomComplet
	
	;FichMem    struc
	;	Hmem     dd ?
	;	Mpoint   dd ?
	;	Taille   dd ?
	;FichMem    ends 

	mov ebx,PileMem 
	invoke RtlZeroMemory,addr InfosFiles,sizeof InfosFiles
	invoke FindFirstFile,NomAediter,addr InfosFiles
		
	;----------------------------------------------------------
	; taille du fichier nFileSizeHigh; DWORD    nFileSizeLow WIN32_FIND_DATA
	;   nom court ou nom long sans chemin ?         
	;-----------------------------------------------------------
	
	.if eax==INVALID_HANDLE_VALUE		 
		mov retour,0          
		jmp FindeLoadFile
	.else
		mov edx,eax
		invoke FindClose,edx
		mov retour,1	   		
	.endif

	invoke CreateFile,NomAediter,GENERIC_READ,NULL,\
			NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	.if eax==INVALID_HANDLE_VALUE
		;invoke  MessageBox,NULL,SADD(" Erreur d'ouverture Fichier "),\
		;			SADD("LoadFile"),MB_OK
		mov retour,0
		jmp FindeLoadFile
	.endif 
	mov hFile,eax 
;------------------------------------------------------------
	mov ecx,InfosFiles.nFileSizeLow
	mov dword ptr (FichMem ptr [ebx]).Taille,ecx
	inc ecx			;pour rajouter le zero en fin de fichier
	add ecx,32		;mmx utilise des registres de 16 bytes
	and ecx,0FFFFFFF0h	;rounded 16 bytes upper
	invoke GlobalAlloc,GMEM_MOVEABLE or GMEM_ZEROINIT,ecx					
	.if eax == 0
		;invoke  MessageBox,NULL,SADD("Pas assez de place mmoire "),\
		;			SADD("GlobalAlloc"),MB_OK
		mov retour,0
		jmp FindeLoadFile
	.endif            
	mov  hMemory,eax
	mov dword ptr (FichMem ptr [ebx]).Hmem,eax
	;obtenir le pointeur de memoire
	invoke GlobalLock,hMemory
	mov  pMemory,eax
	mov dword ptr (FichMem ptr [ebx]).Mpoint,eax

	mov eax,InfosFiles.nFileSizeLow  
	mov NbOctetsaLire,eax
	invoke ReadFile,hFile,pMemory,NbOctetsaLire,addr NbOctetsLus,NULL
			
	;-------------------------
	;libr la memoire ,ferm le fichier ouvert
	;-------------------------
	; invoke GlobalUnlock,pMemory
	; invoke GlobalFree,hMemory
	invoke CloseHandle,hFile
		mov retour,1

FindeLoadFile:
		mov eax,retour
		ret
		

LoadFile endp

;#########################################################################


end