; #########################################################################

	.586                      ; force 32 bit code
	.model flat, stdcall      ; memory model & calling convention
	option casemap :none      ; case sensitive
	.xmm
	
numeroversion equ < @Version>
IF numeroversion LT 615
%ECHO MASM numeroversion impossible de compiler SSE2
.ERR  <Version Masm must be at least 6.15 to compile SSE2>
ENDIF
	; -------------------------------------------------------------------
	; Les fichiers inclus ii ,AUCUN .lib c'est au programme utilisateur
	;	de les fournir
	; -------------------------------------------------------------------
	include \masm32\include\windows.inc
	include \masm32\include\kernel32.inc
	;include \masm32\include\gdi32.inc
	;include \masm32\include\user32.inc
	;include \masm32\include\kernel32.inc
	;include \masm32\include\masm32.inc
	;include macros.txt	
	;include limites.inc

	; ---------------------------------------------------------
	; Les PROTO sont tous regroups dans un fichier .inc du mme
	; nom que la librairie .lib
	; ---------------------------------------------------------



.code

CompteurLignes PROC uses ebx edi esi pmem:DWORD,taille:DWORD
			Local  Nblines:DWORD,count,reste
			local  theEnd:dword
	;init
	mov Nblines,0
	mov reste,0	
	mov edx,pmem
	add edx,taille
	mov theEnd,edx
	mov edx,pmem
	mov esi,edx	
	and edx,0Fh
	.if edx != 0
		;search lines in the non align memory
		mov ecx,16
		sub ecx,edx
		@@:
		.if byte ptr [esi] != 0
			.if word ptr [esi] == 0A0Dh
				inc Nblines			
			.endif
		.else
			mov eax,Nblines
			jmp FindeCompteurLignes
		.endif
		inc esi
		dec ecx
		jnz @B		
	.endif
	;esi point on a 16 aligned memory
	;count the number  of 32 bytes parts 
	mov edx,0
	mov eax,theEnd
	sub eax,esi
	.if eax == 0
		mov eax,Nblines
		jmp FindeCompteurLignes		
	.endif
	.if eax < 32
		mov reste,eax
		mov eax,Nblines		
		jmp EndNonaligned
	.endif
	mov edx,0
	mov ecx,32
	div ecx
	mov count,eax		
	mov reste,edx
	;--------------------------  search in aligned part -------------		
	;init of various register
	mov eax, 0d0d0d0dh	; Ascii 10, linefeed
	movd xmm6, eax
	pshufd xmm6, xmm6, 0	; linefeeds for comparison in xmm2	
	mov eax,Nblines	;line counter
	;ready
	NewBloc:
		;------ align 16 needed ----------
		;1731187 cycles for 22274 lines
		movdqa xmm1,xmm6			;charge 13
		movdqa xmm2,xmm6			;charge 13		
		pcmpeqb  xmm1,[esi]		;cmp with memory align 16		
		pcmpeqb  xmm2,[esi+16]		;cmp with memory ,align 16						
		pmovmskb ecx, xmm1 ; result in ecx 
		pmovmskb edx, xmm2 ; result +16 edx 
		shl edx,16
		add ecx,edx
		jz suite
		NbLineBreak:
		bsf	edx,	ecx
		jz suite
		.if 	word	ptr [edx+esi] == 0A0Dh
			inc	eax
		.endif
		btr	ecx,	edx
		jmp NbLineBreak
	suite:
	lea esi,[esi+32]
	dec count
	jnz NewBloc
	
EndNonaligned:	
	.if reste != 0
		mov ecx,reste
		@@:
		.if word ptr [esi] == 0A0Dh
			inc eax
		.endif	
		inc esi
		dec ecx
		jnz @B						
	.endif
	
FindeCompteurLignes:
ret
CompteurLignes endp

end