; #########################################################################

      .586                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive
	.xmm
	
numeroversion equ < @Version>
IF numeroversion LT 615
   %ECHO MASM numeroversion impossible de compiler SSE2
   .ERR  <Version Masm must be at least 6.15 to compile SSE2>
ENDIF
       include \masm32\include\windows.inc
	include \masm32\include\kernel32.inc
        include local_macros.txt	

      EXTERNDEF CompteurLignes :PROTO :DWORD,:DWORD

LIGNE STRUCT
	pointeur 	dd ?
	taille	dd ?
LIGNE ENDS
INFORMETEXT 	struct
	Hfichier      dd 0            ;handle,pointeur et taille du fichier texte en mmoire
	Pfichier      dd 0
	Tfichier      dd 0
	Hresultat     dd 0            ;Tableau de pointeurs et taille des lignes
	Presultat     dd 0
	Tresultat     dd 0
;------------------------------- option -------------------------------------------------
	Hsortie       dd 0	      ;handle ventuelle de fichier de sortie
;-------------------------------- input -------------------
	Tache         dd 0	      ;la tache voulue de 1  5,1 init est optionnel	
	NumeroLigne   dd 0	      ; numero de ligne voulue	
;---------------------------------output anti memory leak --------------------------------
	MaxLen	      dd 0	      ;la longueur de la ligne la plus longue
	NumLineMax    dd 0	      ;Son numero
;-------------------------------- output general ----------------------------------
	TotalLignes   dd 0	      ;nb total de lignes	
	NBlignesZero  dd 0	      ;1 si derniere ligne termine par zero
;---------------------------------output info ligne -------------------------------
	LenLigne      dd 0            ;longeur sans le 0D0A
	Pligne        dd 0	      ;pointeur de la ligne
INFORMETEXT 	ends

	
   .data	

    .code


;Optimize ,two scrutations are faster than a call to a dynamic memory allocation

;################################################################
ScrutLigne PROC InfoT:DWORD 
	Local  Nblines:DWORD,count,reste
	local  theEnd:dword
	Local  PointePhrase:DWORD         ;contient le point derniere phrase
	Local  CompteurODOA:DWORD,Compteur,PointeResultat,CPT,multitache
	Local  retour:DWORD
	ZEROLOCALES retour


	;INFO TEXTEQU <(INFORMETEXT ptr [esi])>
	;tache 10 memo ligne dans global 
	
	pushad 
	mov esi,InfoT
	call controle			;positionne edx sur la tache
	over_controle:
	.if eax == 0
		jmp FindeScrutLigne
	.endif
	
	;------------------------------ debut des taches --------------------------------------
       .if edx == 1 
		;on n'a besoin , a la premiere passe que de 
		;CompteurODOA  et de Compteur pour calculer la taille de mmoire ncessaire
	 		;Nombre de lignes termines par retourligne et
			;l'ventuelle ligne inacheve
			call passeUne		;gain de temps 20 ms sur 120 130,plus regulier
			;le fichier avec zero ligne est limin
			;------ CompteurODOA et Compteur permettent de calculer l'espace mmoire
			;Nblignes = (CompteurODOA + Compteur)* sizeof LIGNE ;8
			mov eax,CompteurODOA
			add eax,Compteur
			mov CPT,eax
			call CreeTamponLignes
 			;INFO.Presultat et PointeResultat donnent le pointeur mmoire
			call Scrutationdeux
			;termine sans incident
			mov eax,CompteurODOA
			add eax,Compteur
			PuPo [esi].INFORMETEXT.TotalLignes,eax
			PuPo [esi].INFORMETEXT.NBlignesZero,Compteur			
			mov retour, 1                    ;succs
           
       .elseif edx == 2 || edx == 3
		;--------- charger les infos lignes----------
		.if dword ptr [esi].INFORMETEXT.NumeroLigne < 1
			mov retour,0
			jmp FindeScrutLigne
		.endif
		mov edx,[esi].INFORMETEXT.TotalLignes
		.if dword ptr [esi].INFORMETEXT.NumeroLigne > edx
			mov retour,0
			jmp FindeScrutLigne
		.endif		
		;le numro de ligne est valide
		mov edi,[esi].INFORMETEXT.Presultat   ;charge le pointeur de resultat
		mov eax,[esi].INFORMETEXT.NumeroLigne ;le numero de ligne
		dec eax		;base 0
		mov ecx,8
		xor edx,edx
		mul ecx
		add edi,eax        
		mov eax,[edi] 
		mov [esi].INFORMETEXT.Pligne,eax		;premier mot pointeur ligne
		mov eax,[edi+4] 
		mov [esi].INFORMETEXT.LenLigne,eax	;deuxieme mot longueur
		mov retour,1
	.elseif edx == 4    			;tout vider
		call purger			
	.elseif edx == 5
		;transformer les chaines en asciiz
		mov edi,[esi].INFORMETEXT.Presultat
		mov ecx,[esi].INFORMETEXT.TotalLignes	;et uniquement celles la !
		sub ecx,[esi].INFORMETEXT.NBlignesZero
		xor eax,eax
		.if ecx != 0 && edi != 0
			@@:
			mov ebx,[edi]		;pointeur ligne
			mov edx,[edi+4]		;longueur ligne,peut tre nulle
			mov word ptr [ebx+edx],ax
			add edi,8
			dec ecx
			.if ecx != 0
				.if ecx == 2
					mov eax,0	;debug
				.endif
				jmp @B
			.endif
			mov retour,1
		.else
			mov retour,0
		.endif
	.elseif edx == 6
		call purgerResssource				
	.endif
	.if multitache != 0 && retour == 1  ;la tache d'init s'est bien pass
		mov edx,multitache
		mov multitache,0
		mov retour,0
		mov eax,1
		mov esi,InfoT ;precaution
		jmp over_controle
	.endif	

FindeScrutLigne:
	PoPad
	push ebx
	mov ebx,InfoT
	.if dword ptr (INFORMETEXT ptr [ebx]).Tache == 3		;un petit plus
		mov esi,(INFORMETEXT ptr [ebx]).Pligne
		mov ecx,(INFORMETEXT ptr [ebx]).LenLigne
	.endif
	pop ebx
	
	mov eax,retour	
	ret
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;----------------------------------------- sub ------------------------------------------------
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
passeUne:
	mov eax,[esi].INFORMETEXT.Tfichier
	.if  eax != 0
		invoke CompteurLignes,[esi].INFORMETEXT.Pfichier,
						[esi].INFORMETEXT.Tfichier
		mov CompteurODOA,eax	
	.else
		pop eax	;limine call
		mov retour,0
		jmp FindeScrutLigne
	.endif

RETN

controle:
	.if dword ptr [esi].INFORMETEXT.Tfichier <= 2 ;Taille fichier trop petite
		mov eax,0
		mov retour,0
		retn
	.endif
	mov edx,[esi].INFORMETEXT.Tache	
	.if edx > 0 && edx < 7           ;taches comprises entre 1 et 6
		.if [esi].INFORMETEXT.Hresultat == 0
			.if edx == 2 || edx == 3 || edx == 5
				mov multitache,edx	;faire l'init avant la lecture
				mov edx,1	
			.endif
		.endif	
	       mov eax,1	;OK
	.else
		mov eax,0
		mov retour,0
	.endif
retn	
purger:
	mov esi,InfoT
	mov edx,[esi].INFORMETEXT.Pfichier
	.if edx != 0
		invoke GlobalUnlock,edx
		mov edx,[esi].INFORMETEXT.Hfichier
		invoke GlobalFree,edx
		.if eax != 0				
			;invoke MessageBox,NULL,SADR("GlobalFree Hfichier failed,exception gnr"),
			;		SADR("ScrutLigne "),MB_OK
		.endif
	.endif						
	mov edx,[esi].INFORMETEXT.Presultat
	mov ecx,[esi].INFORMETEXT.Hresultat
	.if edx != 0
		invoke HeapFree,ecx,NULL,edx
		.if eax == 0				
			;invoke MessageBox,NULL,SADR("GlobalFree Hresultat failed,exception gnr"),
			;		SADR("ScrutLigne "),MB_OK
		.endif
	.endif
	mov edx,[esi].INFORMETEXT.Hsortie	
	.if edx != 0
		invoke  CloseHandle,edx
		.if eax == 0				
			;invoke MessageBox,NULL,SADR("CloseHandle Hsortie failed,exception gnr"),
			;		SADR("ScrutLigne "),MB_OK
		.endif			
	.endif		
	invoke RtlZeroMemory,InfoT,sizeof INFORMETEXT
	mov retour,1
retn
;-------------------------------------------------------------------------------
purgerResssource:
	mov esi,InfoT
	mov edx,[esi].INFORMETEXT.Presultat
	.if edx != 0
		invoke GlobalUnlock,edx
		mov edx,[esi].INFORMETEXT.Hresultat
		invoke GlobalFree,[esi].INFORMETEXT.Hresultat
		.if eax != 0				
			;invoke MessageBox,NULL,SADR("GlobalFree Hresultat failed,exception gnr"),
			;		SADR("ScrutLigne "),MB_OK
		.endif
	.endif
	mov edx,[esi].INFORMETEXT.Hsortie	
	.if edx != 0
		invoke  CloseHandle,edx
		.if eax == 0				
			;invoke MessageBox,NULL,SADR("CloseHandle Hsortie failed,exception gnr"),
			;		SADR("ScrutLigne "),MB_OK
		.endif			
	.endif		
	invoke RtlZeroMemory,InfoT,sizeof INFORMETEXT
	mov retour,1
retn
;------------------------------------------------------------------------------------------
CreeTamponLignes:
;cre le tampon mmoire
		invoke GetProcessHeap		
		mov  [esi].INFORMETEXT.Hresultat,eax
		.if eax == 0
			jmp memerreur
		.endif

		mov esi,InfoT
		mov eax,CompteurODOA
		inc eax			;une ventuelle ligne non finie par 0D0AH
		mov ecx,8               ;4 bytes * 2 (pointeur ,taille)
		xor edx,edx
		mul ecx		
		.if edx != 0	;trop grossse mmoire
			mov retour,0
			pop eax	;elimine call
			jmp FindeScrutLigne
		.endif
		mov [esi].INFORMETEXT.Tresultat,eax
		mov ecx,eax
		inc ecx			;beau bloc zero terminated
		add ecx,16
		and ecx,-16			;arrondi la taille aux 16 bytes suprieur
		;obtenir le pointeur de memoire
		invoke HeapAlloc,[esi].INFORMETEXT.Hresultat,HEAP_ZERO_MEMORY,ecx
		.if eax==0
			memerreur:
			InsTxt aPetitep,"erreur pointeur memoire ",0
			;invoke  MessageBox,NULL,ADDR aPetitep,SADR("GlobalLock"),MB_OK
			pop eax	;elimine call			
			mov retour,0
			jmp FindeScrutLigne	;chec
		.endif    
 		mov  [esi].INFORMETEXT.Presultat,eax
		mov  PointeResultat,eax  ; pour la deuxieme scrutation
retn
;----------------------------------------------------------------------------------------

Scrutationdeux:
	;-----------------------------------------------------------------------------------------
      ;------------------------------- deuxime scrutation ------------------------------------
	;------------------------------------------------------------------------------------------
	;---------- fin init avec esi ---------------
;-------------------------------------------------------------------------------------
	;le zero ligne a t limin	
	mov edi,InfoT			;infotextascii
	mov Nblines,0
	mov reste,0	
	mov edx,[esi].INFORMETEXT.Pfichier
	mov PointePhrase,edx
	add edx,[esi].INFORMETEXT.Tfichier
	mov theEnd,edx
	mov edx,[esi].INFORMETEXT.Pfichier
	mov esi,edx	
	and edx,0Fh
	.if edx != 0
		;search lines in the non align memory
		mov ecx,16
		sub ecx,edx
		@@:
		.if byte ptr [esi] != 0
			.if word ptr [esi] == 0A0Dh
				mov edx,PointeResultat
				PuPo [edx].LIGNE.pointeur,PointePhrase				
				mov eax,esi
				sub eax,PointePhrase
				mov [edx].LIGNE.taille,eax
				call MaxLine
				add PointeResultat,8
				mov PointePhrase,esi
				add PointePhrase,2
				;inc Nblines			
			.endif
		.else
			jmp FindeMemoriseLigne
		.endif
		inc esi
		dec ecx
		jnz @B		
	.endif
	;esi point on a 16 aligned memory
	;count the number  of 32 bytes parts 
	mov edx,0
	mov eax,theEnd
	sub eax,esi
	.if eax == 0
		jmp FindeMemoriseLigne		
	.endif
	.if eax < 32
		mov reste,eax
		jmp EndNonaligned
	.endif
	mov edx,0
	mov ecx,32
	div ecx
	mov count,eax		
	mov reste,edx
	;--------------------------  search in aligned part -------------		
	;init of various register
	mov eax, 0d0d0d0dh	; Ascii 10, linefeed
	movd xmm6, eax
	pshufd xmm6, xmm6, 0	; linefeeds for comparison in xmm2	
	;ready
	NewBloc:
		;------ align 16 needed ----------
		;1731187 cycles for 22274 lines
		movdqa xmm1,xmm6			;charge 13
		movdqa xmm2,xmm6			;charge 13		
		pcmpeqb  xmm1,[esi]		;cmp with memory align 16		
		pcmpeqb  xmm2,[esi+16]		;cmp with memory ,align 16						
		pmovmskb ecx, xmm1 ; result in ecx 
		pmovmskb edx, xmm2 ; result +16 edx 
		shl edx,16
		add ecx,edx
		jz suite
		NbLineBreak:
		bsf	edx,	ecx
		jz suite
		.if 	word	ptr [edx+esi] == 0A0Dh
				push edx
				push ecx
				mov ecx,edx
				mov edx,PointeResultat
				PuPo [edx].LIGNE.pointeur,PointePhrase				
				mov eax,esi
				add eax,ecx
				sub eax,PointePhrase
				mov [edx].LIGNE.taille,eax
				call MaxLine
				add PointeResultat,8
				mov PointePhrase,esi
				add PointePhrase,ecx
				add PointePhrase,2		
				pop ecx
				pop edx
		.endif
		btr	ecx,	edx
		jmp NbLineBreak
	suite:
	lea esi,[esi+32]
	dec count
	jnz NewBloc
	
EndNonaligned:	
	.if reste != 0
		mov ecx,reste
		@@:
		.if word ptr [esi] == 0A0Dh
			mov edx,PointeResultat
			PuPo [edx].LIGNE.pointeur,PointePhrase				
			mov eax,esi
			sub eax,PointePhrase
			mov [edx].LIGNE.taille,eax
			call MaxLine
			add PointeResultat,8
			mov PointePhrase,esi
			add PointePhrase,2				
		.endif	
		inc esi
		dec ecx
		jnz @B									
	.endif
;verifier que le fichier texte se termine par 0A
	mov eax,esi	;debug
	mov ecx,[edi].INFORMETEXT.Presultat
	.if byte ptr [esi-1] != 0Ah
		mov edx,PointeResultat	
		mov [edi].INFORMETEXT.NBlignesZero,1
		mov Compteur,1	;------ voir proc principal -------
		PuPo [edx].LIGNE.pointeur,PointePhrase				
		mov eax,esi
		sub eax,PointePhrase
		mov [edx].LIGNE.taille,eax		
	.endif

;---------------------------------------------------------------------------------------	
	
FindeMemoriseLigne:
	mov esi,InfoT
retn
MaxLine:
	;change eax
	;rcupre les informations prcdemment enregistrer dans PointeResultat
	mov edx,[edi].INFORMETEXT.MaxLen
	.if eax > edx
		;mmo de la longueur ligne la plus grande
		mov [edi].INFORMETEXT.MaxLen,eax
		;mmo du numro ligne
		mov eax,PointeResultat
		sub eax,[edi].INFORMETEXT.Presultat
		shr eax,3		;division par 8
		inc eax
		mov [edi].INFORMETEXT.NumLineMax,eax
	.endif
retn



ScrutLigne endp



end